=== debian/changelog ===
openqa (4.6.1640268275.25ac0d7-2) unstable; urgency=medium

  * openqa-client should be Architecture: all

 -- Philip Hands <phil@hands.com>  Sat, 01 Jan 2022 09:55:52 +0100

openqa (4.6.1640268275.25ac0d7-1) unstable; urgency=medium

  * New upstream release.
  * openqa-common: depend on libfilesys-df-perl
  * fix lintian JS overrides
  * using packaged bootstrap4 breaks scrollbar text alignment: add padding
  * install systemd files under /lib so that dh_installsystemd notices them
  * use execute_(before|after)_dh_* in rules
  * deal with dh_missing errors
  * postinst chmod renders lintian-override redundant
  * ensure that missing assets result in failure
  * node-jquery-ujs 1.2.3-1: rails.js --> /usr/share

 -- Philip Hands <phil@hands.com>  Fri, 31 Dec 2021 22:34:51 +0100

openqa (4.6.1632930736.2895850-1) unstable; urgency=medium

  * Initial release (Closes: #840253)

 -- Philip Hands <phil@hands.com>  Thu, 30 Sep 2021 20:13:08 +0200
