## openqa 4.6.1668594742.66ecc7a70

=== debian/changelog ===
openqa (4.6.1668594742.66ecc7a70-1) unstable; urgency=medium

  * Update to new upstream version 4.6.1668594742.66ecc7a70.
  * switch to dgit-debrebase workflow, and reconstruct separate patches

 -- Philip Hands <phil@hands.com>  Thu, 17 Nov 2022 11:14:56 +0100

openqa (4.6.1653336570.10bff0d-3) unstable; urgency=medium

  * bump Standards-Version
  * depend libcpanel-json-xs-perl & libmoose-perl (closes: 1019920)
  * lintian tidyage

 -- Philip Hands <phil@hands.com>  Mon, 10 Oct 2022 20:28:51 +0200

openqa (4.6.1653336570.10bff0d-1) unstable; urgency=medium

  * New upstream release.

 -- Philip Hands <phil@hands.com>  Tue, 24 May 2022 21:07:23 +0200

openqa (4.6.1648473912.da11be7-1) unstable; urgency=medium

  * Create and install manpages
  * openqa-label-all now uses openqa-cli
  * openqa-cli requires Time::Moment
  * adjust self-references in openqa-*-templates(1)
  * New upstream release.
  * disable shepherd.js tour (until shepherd.js is packaged)

 -- Philip Hands <phil@hands.com>  Mon, 23 May 2022 17:39:08 +0200
