=== debian/control ===
--- 
+++ 
@@ -80,7 +80,7 @@
                liburi-perl,
                libwww-perl,
                perl,
-               libminion-perl,
+               libminion-perl (>= 10.25),
 ### for testcases
                libperl-critic-perl,
                libperl-critic-freenode-perl,
@@ -115,16 +115,16 @@
                fonts-roboto,
                libjs-chosen,
                libjs-jquery-datatables,
-               libjs-bootstrap4,
-               libjs-bootstrap-tour,
+               libjs-bootstrap4 (>= 4.6.1),
                libjs-codemirror,
-               libjs-jquery,
+               libjs-jquery (>= 3.6.0),
                libjs-jquery-timeago,
-               libjs-popper.js,
+               libjs-popper.js (>= 1.16.1),
                node-jquery-ujs,
-Standards-Version: 4.6.0.1
+               libcode-tidyall-perl,
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Homepage: http://open.qa
+Homepage: https://open.qa
 Vcs-Git: https://salsa.debian.org/debian/openqa.git
 Vcs-Browser: https://salsa.debian.org/debian/openqa
 
@@ -144,15 +144,13 @@
          libtext-diff-perl,
          libyaml-pp-perl,
          libdatetime-format-pg-perl,
-         libtime-moment-perl,
-         libminion-perl,
+         libminion-perl (>= 10.25),
          libmojo-pg-perl,
          libcommonmark-perl,
          postgresql,
          libclass-c3-componentised-perl,
          fonts-fork-awesome,
          libjs-jquery-datatables,
-         libjs-bootstrap-tour,
          libjs-codemirror,
          libjs-jquery,
          libjs-jquery-timeago,
@@ -221,6 +219,9 @@
          libregexp-common-perl,
          libjson-validator-perl,
          libfilesys-df-perl,
+         libtime-moment-perl,
+         libcpanel-json-xs-perl,
+         libmoose-perl,
 Recommends:
          git-lfs,
 Description: automatic Operating System testing framework (common files)
@@ -286,6 +287,7 @@
 
 Package: openqa-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
 Description: automatic Operating System testing framework - documentation
